Subject: bug#38181: Actual height of mode-line not taken into account

From: Eli Zaretskii <[email-masked]>
Date: Sun, 17 Nov 2019 20:35:55 +0200

> Cc: [email-masked], [email-masked]
> From: martin rudalics <[email-masked]>
> Date: Sun, 17 Nov 2019 19:15:44 +0100
> 
>  > I didn't see where fit-window-to-buffer looks at the height of the
>  > mode line.  What did I miss?
> 
> 'window-text-pixel-size' does it (triggered by the sixth argument
> MODE-AND-HEADER-LINE non-nil).

Thanks.  So the only thing that's missing is that it should call
display_mode_lines, and then look at DESIRED_MODE_LINE_HEIGHT instead
of WINDOW_MODE_LINE_HEIGHT?

>  > Suppose we had a Lisp-callable function which would return the height
>  > of the mode line of a window as per the current mode-line-format for
>  > that window -- would that make the solution possible/easier?
> 
> Possible, I think.  If we pass it on to 'window-text-pixel-size', it
> wouldn't even have to be Lisp-callable.  Still, it will penalize every
> ‘fit-window-to-buffer’ call (without a redisplay, though).

Why "penalize"?